package java.nio.channels;

import java.io.IOException;
import java.nio.channels.spi.SelectorProvider;
import java.nio.channels.spi.AbstractInterruptibleChannel;

public abstract class SelectableChannel extends AbstractInterruptibleChannel implements Channel
{
    protected SelectableChannel() {
    }
    
    public abstract SelectorProvider provider();
    
    public abstract int validOps();
    
    public abstract boolean isRegistered();
    
    public abstract SelectionKey keyFor(Selector p0);
    
    public abstract SelectionKey register(Selector p0, int p1, Object p2) throws ClosedChannelException;
    
    public final SelectionKey register(Selector selector, int n) throws ClosedChannelException {
        return this.register(selector, n, null);
    }
    
    public abstract SelectableChannel configureBlocking(boolean p0) throws IOException;
    
    public abstract boolean isBlocking();
    
    public abstract Object blockingLock();
}
